
// --------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------

float4x4 tW : WORLD;                         // the world matrix for transforming the model
float4x4 tWVP : WORLDVIEWPROJECTION;                  // projection matrix: get from renderer

texture Tex0;                                      // texture
texture Tex1;
texture Tex2;
texture Tex3;
texture Tex4;
texture Tex5;
texture Tex6;
texture Tex7;
texture Tex8;
texture Tex9;
texture Tex10;
texture Tex11;
texture Tex12;
texture Tex13;
texture Tex14;
texture Tex15;

sampler Samp0 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex0);
};
sampler Samp1 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex1);
};
sampler Samp2 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex2);
};
sampler Samp3 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex3);
};
sampler Samp4 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex4);
};
sampler Samp5 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex5);
};
sampler Samp6 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex6);
};
sampler Samp7 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex7);
};
sampler Samp8 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex8);
};
sampler Samp9 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex9);
};
sampler Samp10 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex10);
};
sampler Samp11 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex11);
};
sampler Samp12 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex12);
};
sampler Samp13 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex13);
};
sampler Samp14 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex14);
};
sampler Samp15 = sampler_state                       // a sampler for making the texture-lookup
{
    Texture   = (Tex15);
};


int framecount;
int renderpass;
bool invert;

// -------------------------------------------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// -------------------------------------------------------------------------------------------------------------------------------------

struct vs2ps                                            // data that ist returned by the vertexshader
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

vs2ps VS(
    float4 PosO  : POSITION,
    float2 TexCd  : TEXCOORD0)
{
    vs2ps Out;
    // transform11 position:
    Out.Pos  = mul(PosO, tWVP);                          // position (projected)
    Out.TexCd = TexCd;
    
    return Out;    
}


// --------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------

float4 PSPlainVideo(float2 TexPos  : TEXCOORD0) : COLOR
{
  float4 col = tex2D(Samp14, TexPos);
  if (renderpass > 0)
    col.a = 0;
  return col;
}

float4 PS(float2 TexCd  : TEXCOORD0, uniform int Mode) : COLOR
{
 float4 g = tex2D(Samp15, TexCd);
 //g = (0.299 * g.r + 0.587 * g.g + 0.114 * g.b) / 3;
// if (invert)
 //  g = 1 - g;

 int t;
 //which timeslice to sample from
 if (Mode == 0)
 {
   t = round(g.r * framecount);
 }
 else if (Mode == 1)
 {
   t = round(TexCd.x * framecount);
 }
 else if (Mode == 2)
 {
   t = round(TexCd.y * framecount);
 }
 else if (Mode == 3)
 {
   //t = round(distance(TexCd, float2(0.5, 0.5)) * framecount);
 }
 t -= renderpass * 15;

 //do the sampling
 if (t == 0)
 {
   return tex2D(Samp0, TexCd);
 }
 else if (t == 1)
 {
   return tex2D(Samp1, TexCd);
 }
 else if (t == 2)
 {
   return tex2D(Samp2, TexCd);
 }
 else if (t == 3)
 {
   return tex2D(Samp3, TexCd);
 }
 else if (t == 4)
 {
   return tex2D(Samp4, TexCd);
 }
 else if (t == 5)
 {
   return tex2D(Samp5, TexCd);
 }
 else if (t == 6)
 {
   return tex2D(Samp6, TexCd);
 }
 else if (t == 7)
 {
   return tex2D(Samp7, TexCd);
 }
 else if (t == 8)
 {
   return tex2D(Samp8, TexCd);
 }
 else if (t == 9)
 {
   return tex2D(Samp9, TexCd);
 }
 else if (t == 10)
 {
   return tex2D(Samp10, TexCd);
 }
 else if (t == 11)
 {
   return tex2D(Samp11, TexCd);
 }
 else if (t == 12)
 {
   return tex2D(Samp12, TexCd);
 }
 else if (t == 13)
 {
   return tex2D(Samp13, TexCd);
 }
 else if (t == 14)
 {
   return tex2D(Samp14, TexCd);
 }
 else
 {
   return (0, 0, 0, 0);
 }
}



// --------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------

int Mode;

technique TTimeWarp
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS(Mode);
    }  
}

technique TPlainVideo
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_1_0 PSPlainVideo();
    }
}
